<?php
namespace SGalinski\SgJobs\Controller;

/***************************************************************
 *  Copyright notice
 *
 *  (c) sgalinski Internet Services (https://www.sgalinski.de)
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

use SGalinski\SgJobs\Service\ModerationService;
use TYPO3\CMS\Backend\Template\Components\DocHeaderComponent;
use TYPO3\CMS\Backend\Utility\BackendUtility;
use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Extbase\Mvc\Controller\ActionController;

/**
 * The moderation controller.
 */
class ModerationController extends ActionController {
	/**
	 * DocHeaderComponent
	 *
	 * @var DocHeaderComponent
	 */
	protected $docHeaderComponent;

	/**
	 * ModerationService
	 *
	 * @var ModerationService
	 */
	protected $moderationService;

	/**
	 * @var \SGalinski\SgJobs\Domain\Repository\BaseRepository
	 * @inject
	 */
	private $baseRepository;

	/**
	 * @return void
	 */
	public function initializeIndexAction() {
		$this->defaultViewObjectName = 'TYPO3\CMS\Fluid\View\TemplateView';
	}

	/**
	 * Shows all the data for the selected page browser page in the backend.
	 *
	 * @return void
	 */
	public function listAction() {
		// create doc header component
		$pageUid = (int) GeneralUtility::_GP('id');
		$pageInfo = BackendUtility::readPageAccess($pageUid, $GLOBALS['BE_USER']->getPagePermsClause(1));
		$this->docHeaderComponent = GeneralUtility::makeInstance(DocHeaderComponent::class);

		$this->docHeaderComponent->setMetaInformation($pageInfo);
		$this->moderationService = GeneralUtility::makeInstance(ModerationService::class);
		$this->moderationService->makeButtons($this->docHeaderComponent, $this->request->getPluginName());
		$this->view->assign('docHeader', $this->docHeaderComponent->docHeaderContent());

		$items = $this->baseRepository->findAllBackend($pageUid, TRUE);
		$this->view->assign('pageUid', $pageUid);
		$this->view->assign('items', $items);
	}
}
